<?php
//	Script Version 7.5.7

// Require the library
require ("../libs/admin.inc.php");
require ("../languages/{$config['LANGUAGE']}/admin/generic.php");

// -------------
// Get the input
$returntab = get_input("returntab","post");
$island = get_input("island","post");
$portal_name = get_input("portal_name","post");
$portal_cache = get_input("portal_cache","post");
$always_build = get_input("always_build","post");
$items = get_input("items","post");


// -----------------
// Get the user info

$userob = new user;
$user = $userob -> authenticate("USER_DISPLAY_NAME");

$admin = new Admin;

$admin->doAuth();

$query = "
	select FORUM_ID
	from {$config['TABLE_PREFIX']}FORUMS
	where FORUM_IS_GALLERY > 0
";
$sth = $dbh->do_query($query,__LINE__,__FILE__);
$galleries = array();
while(list($fid) = $dbh->fetch_array($sth)) {
	$galleries[$fid] = $fid;
} // end while

foreach($_POST['source'] as $k => $v) {
	if ($v == "category" || !isset($galleries[$v])) {
		unset($_POST['source'][$k]);
	} // end if
} // end foreach


if (!sizeof($_POST['source'])) {
	$admin->error($ubbt_lang['NO_SOURCE']);
} // end if

$portal_cache = $portal_cache * 60;
$query = "
	update 	{$config['TABLE_PREFIX']}PORTAL_BOXES
	set	PORTAL_NAME = ? ,
		PORTAL_CACHE = ? ,
		PORTAL_FORUMS = ? ,
		PORTAL_ITEMS = ?
	where	PORTAL_ID = ?
";

$dbh->do_placeholder_query($query,array($portal_name,$portal_cache,serialize($_POST['source']),$items,$island),__LINE__,__FILE__);

if ($always_build && !in_array("gallery_island_{$island}",$config['BUILD_ISLANDS'])) {
	// put it in
	if (is_array($config['BUILD_ISLANDS'])) {
		array_push($config['BUILD_ISLANDS'],"gallery_island_{$island}");
	} else {
		$config['BUILD_ISLANDS'][] = "gallery_island_{$island}";
	} // end if

	$_POST['BUILD_ISLANDS'] = $config['BUILD_ISLANDS'];
	$newconfig = array("BUILD_ISLANDS");
	include("./doeditconfig.php");
	
} else {
	// take it out

	$newarray = array();
	foreach($config['BUILD_ISLANDS'] as $k => $v) {
		if ($v == "gallery_island_{$island}") continue;
		$newarray[] = $v;
	}

	$_POST['BUILD_ISLANDS'] = $newarray;	
	$newconfig = array("BUILD_ISLANDS");
	include("./doeditconfig.php");
}

admin_log("EDIT_GALLERY_ISLAND","<a href='{$config['BASE_URL']}/admin/editgalleryisland.php?island=$island&returntab=$returntab' target='_blank'>$portal_name</a>");

$admin->redirect($ubbt_lang['GALLERY_ISL_UPDATED'],"{$config['BASE_URL']}/admin/editgalleryisland.php?island=$island&returntab=$returntab",$ubbt_lang['GALLERY_ISL_F_LOC']);

?>
