<?php
//	Script Version 7.5.7

// Require the library
require ("../libs/admin.inc.php");
require ("../languages/{$config['LANGUAGE']}/admin/movethreads.php");
require ("../languages/{$config['LANGUAGE']}/admin/generic.php");

// -------------
// Get the input
$returntab = get_input("returntab","get");

// -----------------
// Get the user info

$userob = new user;
$user = $userob -> authenticate("USER_DISPLAY_NAME");

$admin = new Admin;

$admin->doAuth();

$tabs = array(
	"{$ubbt_lang['MOVE_THREADS']}" => ""
);

$admin->setCurrentMenu($ubbt_lang['MOVE_THREADS']);
$admin->setReturnTab($returntab);
$admin->setPageTitle($ubbt_lang['MOVE_THREADS']);
$admin->sendHeader();
$admin->createTopTabs($tabs,$returntab);

$temp = getdate();
$thisyear = $temp["year"];
$thismonth = $temp["mon"];
$thisday = $temp["mday"];

// Build the year list
$yearlist = "<select name=\"olderyear\">";
$yearlist .= "<option></option>";
for ($i=$thisyear;$i>1990;$i--) {
	$yearlist .= "<option>$i</option>";
}
$yearlist .= "</select>";

// Build the month list
$monthlist = "<select name=\"oldermonth\">";
$monthlist .= "<option></option>";
for ($i=1;$i<=12;$i++) {
	$month = "MONTH$i";
	$monthlist .= "<option value=\"$i\">{$ubbt_lang[$month]}</option>";
}
$monthlist .= "</select>";

// Build the day list
$daylist = "<select name=\"olderday\">";
$daylist .= "<option></option>";
for ($i=1;$i<=31;$i++) {
	$daylist .= "<option value=\"$i\">$i</option>";
}
$daylist .= "</select>";

$yearlist_n = preg_replace("/olderyear/","neweryear",$yearlist);
$monthlist_n = preg_replace("/oldermonth/","newermonth",$monthlist);
$daylist_n = preg_replace("/olderday/","newerday",$daylist);

include("{$config['FULL_PATH']}/cache/forum_cache.php");
if (!sizeof($tree)) {
	list($tree,$style_cache,$lang_cache) = build_forum_cache();
}
		
$sourcelist = "<select name=\"source[]\" multiple=\"multiple\" size=\"10\">";
$sourcelist .= "<option value=\"allforums\">{$ubbt_lang['ALLFORUMS']}</option>";
$targetlist = "<select name=\"target\">";

$category = "";
$forums = 0;
foreach($tree['categories'] as $cat => $cat_title) {
	$category = "";
	$forums = 0;
	$category .= "<option value=\"category\">$cat_title ------</option>";
	if (!isset($tree[$cat])) continue;
	foreach($tree[$cat] as $forum_id => $forum_title) {
		$category .= "<option value=\"$forum_id\">$forum_title</option>";
		$forums++;
	}
	if ($forums) {
		$sourcelist .= $category;
		$targetlist .= $category;
	}
}

$sourcelist .= "</select>";
$targetlist .= "</select>";

// Include the template
include("../templates/default/admin/movethreads.tmpl");

$admin->sendFooter();
?>
