<?php defined( 'UBB_MAIN_PROGRAM' ) or exit;
//  Script Version 7.5.7



function page_mycookies_gpc () {
	return array(
		"input" => array(
			"doExpire" => array("doExpire","post","int"),
		),
		"wordlets" => array("mycookies"),
		"user_fields" => "",
		"regonly" => 0,
		"admin_only" => 0,
		"admin_or_mod" => 0,
	);
} // end page_mycookies_gpc

function page_mycookies_run () {

	global $smarty,$user,$in,$ubbt_lang,$config,$forumvisit,$visit,$dbh,$html;

	extract($in, EXTR_OVERWRITE | EXTR_REFS); // quick and dirty fix - extract hash values as vars

	// ---------------------
	// Grab the cookie array
	$CookieArray = $_COOKIE;

	// ----------------------------
	// Show the current cookies
	if (!$doExpire) {
		$cookiearray = array();
		if (is_array($CookieArray) && !empty($CookieArray)) {
			$cookierow = 0;
			while(list($cName,$cValue) = each($CookieArray)) {
				if ($cName == "{$config['COOKIE_PREFIX']}ubbt_dob"
				|| $cName == "{$config['COOKIE_PREFIX']}ubbt_pass" 
				|| $cName == "{$config['COOKIE_PREFIX']}ubbt_x" ) {
					continue;
				}
				$cookiearray[$cookierow]['cName'] = $cName;
				$cookiearray[$cookierow]['cValue'] = htmlspecialchars($cValue);
				$cookierow++;
			}
		}

		$smarty_data = array(
			"cookiearray" => $cookiearray,
			"mystuff" => $html->mystuff(),
		);

		$cfrm = make_ubb_url("ubb=cfrm", "", false);
		return array(
			"header" => array (
				"title" => $config['COMMUNITY_TITLE'],
				"refresh" => 0,
				"user" => $user,
				"Board" => "",
				"bypass" => 0,
				"onload" => "",
				"breadcrumb" => <<<BREADCRUMB
 <a href="{$cfrm}">{$ubbt_lang['FORUM_TEXT']}</a>
 &raquo;
 {$ubbt_lang['MYCOOKIES']}
BREADCRUMB
				,
			),
			"template" => "mycookies",
			"data" => & $smarty_data,
			"footer" => true,
			"location" => "",
		);

	} else {

		if (is_array($CookieArray) && !empty($CookieArray)) {
			while(list($cName,$cValue) = each($CookieArray)) {
				$cName = str_replace(" ","",$cName);
				if ($cName == "{$config['COOKIE_PREFIX']}ubbt_dob"
				|| $cName == "{$config['COOKIE_PREFIX']}ubbt_pass" 
				|| $cName == "{$config['COOKIE_PRERIX']}ubbt_x" ) {
					continue;
				}
				$true = 1;
				if ($config['COOKIE_PREFIX']) {
					if (!preg_match("/^{$config['COOKIE_PREFIX']}/",$cName)) {
						$true = 0;
					}
				}
				if (preg_match("/^(w3t_|ubbt_|grp_)/",$cName) || $true) {
					// Multiple cookie paths used to expire cookies no longer in use as well.
					$html -> ubbt_setcookie("$cName","", null); // Configured path
					$html -> ubbt_setcookie("$cName","", null,$config['COOKIE_PATH']); // Configured path
					$html -> ubbt_setcookie("$cName","", null,"/"); // Site wide path
				}
			}
		}

		return array(
			"header" => "",
			"template" => "",
			"data" => "",
			"footer" => false,
			"location" => "mycookies",
		);
	}

}

?>
