<?php

//	Script Version 7.5.7

if(!defined("UBB_MAIN_PROGRAM")) exit;

function page_doopenthreads_gpc () {
	return array(
		"input" => array(
			"Number" => array("Number","both","int"),
		),
		"wordlets" => array("admin/generic"),
		"user_fields" => "USER_TOPIC_VIEW_TYPE",
		"regonly" => 1,
		"admin_only" => 0,
		"admin_or_mod" => 1,
	);
} // end page_doopenthreads_gpc

function page_doopenthreads_run () {

	global $user,$in,$ubbt_lang,$config,$forumvisit,$visit,$dbh,$html, $userob;

	extract($in, EXTR_OVERWRITE | EXTR_REFS); // quick and dirty fix - extract hash values as vars

	$query = "
		select FORUM_ID,POST_ID,TOPIC_SUBJECT
		from {$config['TABLE_PREFIX']}TOPICS
		where TOPIC_ID = ?
	";
	$sth = $dbh->do_placeholder_query($query,array($Number),__LINE__,__FILE__);
	list($Keyword,$first_post,$tsubject) = $dbh->fetch_array($sth);
	
	if (!$userob->check_access("forum","LOCK_ANY",$Keyword)) exit;
	
	$query = "
		select FORUM_TITLE,CATEGORY_ID,FORUM_PARENT
		from {$config['TABLE_PREFIX']}FORUMS
		where FORUM_ID = ?
	";
	$sth = $dbh->do_placeholder_query($query,array($Keyword),__LINE__,__FILE__);
	list($Title,$cat_id,$parent_id) = $dbh->fetch_array($sth);

	$query = "
	UPDATE {$config['TABLE_PREFIX']}TOPICS
	SET    TOPIC_STATUS = ''
	WHERE  TOPIC_ID   = ?
	";
	$dbh -> do_placeholder_query($query,array($Number),__LINE__,__FILE__);

	// ---------------
	// Log this action
	admin_log("OPEN_TOPIC", "<a href='" . make_ubb_url("ubb=show{$user['USER_TOPIC_VIEW_TYPE']}&Number=$first_post", $tsubject, false) . "' target='_blank'>$tsubject</a>");
	
	$cfrm = make_ubb_url("ubb=cfrm", "", false);
	$html->send_redirect(
		array(
			"redirect" => "show{$user['USER_TOPIC_VIEW_TYPE']}&Number=$first_post",
			"heading" => $ubbt_lang['COM_HEAD'],
			"body" => $ubbt_lang['COM_BODY'],
			"returnlink" => "",
			"Board" => $Keyword,
			"Category" => $cat_id,
			"parent_forum" => $parent_id,
			"breadcrumb" => <<<BREADCRUMB
 <a href="{$cfrm}">{$ubbt_lang['FORUM_TEXT']}</a>
BREADCRUMB
			,
		)
	);

}

?>
